<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		cedi
 */

/**
 * Get the number of CEDI pages currently in the database.
 *
 * @return integer		The number of pages in the CEDI database
 */
function get_num_cedi_pages()
{
	$value=get_value_newer_than('num_seedy_pages',time()-60*60*24);

	if (is_null($value))
	{
		$_value=$GLOBALS['SITE_DB']->query_value_null_ok('seedy_pages','COUNT(*)');
		if (!($_value>0)) $_value=0;
		$value=strval($_value);
		set_value('num_seedy_pages',$value);
	}

	return intval($value);
}

/**
 * Get the number of CEDI posts currently in the database.
 *
 * @return integer		The number of posts in the CEDI database
 */
function get_num_cedi_posts()
{
	$value=get_value_newer_than('num_seedy_posts',time()-60*60*24);

	if (is_null($value))
	{
		$_value=$GLOBALS['SITE_DB']->query_value_null_ok('seedy_posts','COUNT(*)');
		if (!($_value>0)) $_value=0;
		$value=strval($_value);
		set_value('num_seedy_posts',$value);
	}

	return intval($value);
}

